## Usage

You can find the ReTrace jar in the `lib` directory of the ProGuard distribution. To run ReTrace, just type:

`java -jar retrace.jar [-verbose]` mapping_file [stacktrace_file]

The arguments have the following meaning:

`-verbose` | Optionally specifies to print out more informative stack traces that include not only method names, but also method return types and arguments.
mapping_file | Specifies the name of the mapping file, produced by ProGuard with the option "`-printmapping` mapping_file", while obfuscating the application that produced the stack trace.
stacktrace_file | Optionally specifies the name of the file containing the stack trace. If no file is specified, a stack trace is read from the standard input. Blank lines and unrecognized lines are ignored, as far as possible.

The restored stack trace is printed to the standard output. The completeness of the restored stack trace depends on the presence of line number tables in the obfuscated class files:

- If all line numbers have been preserved while obfuscating the application, ReTrace will be able to restore the stack trace completely.

- If the line numbers have been removed, mapping obfuscated method names back to their original names has become ambiguous. Retrace will list all possible original method names for each line in the stack trace. The user can then try to deduce the actual stack trace manually, based on the logic of the program.

Preserving line number tables is explained in detail in this example in the ProGuard User Manual.

Unobfuscated elements and obfuscated elements for which no mapping is available will be left unchanged.